#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include <MovingAverages.mqh>
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2
//--- plot BaseMa
#property indicator_label1  "BaseMa"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot MaForMa
#property indicator_label2  "MaForMa"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrBlue
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- input parameters
input int      MaPeriod=10;//  
input ENUM_MA_METHOD  Method=MODE_SMA ; //  
input int      Kol_vo=250 ;//-                    
//--- indicator buffers
double         BaseMaBuffer[];
double         MaForMaBuffer[];
int            hiMa   ;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,BaseMaBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,MaForMaBuffer,INDICATOR_DATA);
   ArraySetAsSeries(BaseMaBuffer,true) ;
   ArraySetAsSeries(MaForMaBuffer,true) ;
   switch(Method)
      {
         case (MODE_SMA):
            hiMa=iMA(NULL,0,MaPeriod,0,MODE_SMA,PRICE_CLOSE) ;
            break ;
         case (MODE_EMA):
            hiMa=iMA(NULL,0,MaPeriod,0,MODE_EMA,PRICE_CLOSE) ;
            break ;
         case (MODE_SMMA) :
            hiMa=iMA(NULL,0,MaPeriod,0,MODE_SMMA,PRICE_CLOSE) ;
            break ;
         case (MODE_LWMA) :
            hiMa=iMA(NULL,0,MaPeriod,0,MODE_LWMA,PRICE_CLOSE) ;
      }
   
//---
   return(0);
  }
void OnDeinit(const int reason)
  {
   IndicatorRelease(hiMa);
  }
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
  
    double ima[],Raznica[],bbb;
    int ended ,i,j;
    ArrayResize(Raznica,MaPeriod,4) ;
    if (rates_total < 2*MaPeriod+1)
    return(0);   
    if (prev_calculated == 0)
       ended=rates_total-2*MaPeriod-1 ;
    else 
       ended=rates_total-prev_calculated-1 ;
    if (ended >Kol_vo) ended=Kol_vo ;
    ArraySetAsSeries(price,true) ;
    for ( i=ended; i >=0;  i--)
      {
         CopyBuffer(hiMa,0,i,1,ima) ;
         BaseMaBuffer[i]=ima[0] ;
         BaseMaBuffer[Kol_vo]=EMPTY_VALUE ;
      }
//-------------------------------------------------------------------------------
    for(i=ended ;i>=0 ;i--)
      {
         bbb=0 ;
         for( j=MaPeriod-1 ;j>=0 ;j--)
            {
               bbb=bbb+price[i+j]-BaseMaBuffer[i+j]; 
               //Raznica[j]=price[i+j]-BaseMaBuffer[i+j];
            }
         //bbb=SimpleMA(0,MaPeriod,Raznica) ; 
         MaForMaBuffer[i]=BaseMaBuffer[i]+bbb/MaPeriod;
         //MaForMaBuffer[i]=BaseMaBuffer[i]+bbb; 
         MaForMaBuffer[Kol_vo-MaPeriod]=EMPTY_VALUE;  
      }
    //Alert(" MODE_SMA= ",MODE_SMA) ;
    //Alert(" MODE_EMA= ",MODE_EMA) ;
    //Alert(" MODE_SMMA= ",MODE_SMMA) ;
    //Alert(" MODE_LWMA= ",MODE_LWMA) ;
   return(rates_total);
  }
//+------------------------------------------------------------------+
